package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.annotations.Test;

import java.util.Date;

public class AprovacaoCardapioMatrizPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Aprovação do Cardápio pela Matriz']");
    By telaAprovacao = By.xpath("//div[text() = 'Aprovação do Cardápio pela Matriz']");
    By agrupamentoUnidade = By.xpath("//div[@id = 'GRUPFILI']//span[@zh-icon='no-border search']");
    By limpaAgrupamento = By.xpath("//div[@id = 'GRUPFILI']//span[@zh-icon='no-border close-x']");
    By filtroBusca = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaBusca = By.xpath("//*[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By selecionaCusto = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By checkBoxTodasUnidades = By.xpath("//div[@data-zh-id='12742539022422581008454']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By validaCheckBoxTodasUnidades = By.xpath("//input[@id = 'zh-checkbox-ALL_CDFILIAL']");
    By campoUnidade = By.xpath("//div[@id = 'NMFILIAL']");
    By ckeckBoxUnidade = By.xpath("//div[@id= 'grid-9999']//div[@class = 'th grid-checkbox-column fixed']");
    By btnOk = By.xpath("//div[@id = 'footer']//span[text() = 'Ok']");
    By ckeckBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-ALL_CDSERVFILI']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By validaCheckBoxServicos = By.xpath("//input[@id = 'zh-checkbox-ALL_CDSERVFILI']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By ckeckBoxServico = By.xpath("//div[@id= 'grid-9999']//div[@class = 'th grid-checkbox-column fixed']");
    By buscaTipoCusto = By.xpath("//div[@id = 'NMTIPOCUSTO']//span[@zh-icon='no-border search']");
    By btnCalendario = By.xpath("//div[@id = 'DTMESCARD']//span[@zh-icon='no-border calendar']");
    By mudaAnoAprovacao = By.xpath("//*[@id='popup']/span/section/section/section/div/section/nav/header/div[2]");
    By mesCardapioAprovacao = By.xpath("//div[@class= 'month']//div[text() = 'Jan']");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");
    By observacaoGeral = By.xpath("//textarea[@name = 'DSGERAPROCARDMATR']");
    By selecionaServicoAprovacao = By.xpath("//div[@class = 'tr cell1']//div[@class= 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By selecionaServicoAprovar = By.xpath("//div[@class = 'tr cell2']//div[@class= 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By selecionaTodosServicosAprovacao = By.xpath("//div[@id = 'grid-12742539021351839340443']//div[@class = 'th grid-checkbox-column fixed']");
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnAprovarCardapio = By.xpath("//span[text() = 'Aprovar Cardápio']");
    By btnCancelarAprovacao = By.xpath("//span[text() = 'Cancelar Cardápio']");
    By confirmaAprovacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By negaAprovacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Não']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By btnSalvarObservacao = By.xpath("//span[text() = 'Salvar']");
    By clicarGridTela = By.xpath("//div[@class = 'body-content']");
    By btnOkMensagemAlerta = By.xpath("//button[@class = 'zh-alert-button']//span[text() = 'OK']");
    By limparFiltroRealizado = By.xpath("//section[@class = 'popup-container']//div[@id= 'footer']//a[@data-zh-title-tooltip='Clear Filter (Ctrl+Backspace)']");
    By abreTelaFiltro = By.xpath("//span[@data-zh-icon='filter no-border icon-white']");
    By clearFiltro = By.xpath("//*[@id='footer']/div[2]/ul/li/a");

    //Campos do botão de pesquisa
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div");
    By botaoPesquisarFiltro = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/span[1]");
    By campoProcurar = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");

    //Campo data
    By dataAprovacaoCard = By.xpath("//div[@id='grid-12742539021351839340443']//div[@class = 'body-content']/div[1]//div[@data-zh-field-name='DTAPROCARDMATR']/span");
    By dtAprovacaoCard = By.xpath("//div[@id='grid-12742539021351839340443']//div[@class = 'body-content']/div[2]//div[@data-zh-field-name='DTAPROCARDMATR']/span");
    //Campos Obrigatorios
    By campoObrigatorioUnidade = By.xpath("//div[@data-zh-id='12742539022412219457450']/div[2]/span");
    By campoObrigatorioServico = By.xpath("//div[@data-zh-id='12742539022510623904457']/div[2]/span");
    By campoObrigatorioCusto= By.xpath("//div[@data-zh-id='12742539021245851543463']/div[2]/span");
    By campoObrigatorioCardapio = By.xpath("//div[@data-zh-id='1274253902475137105471']/div[2]/span");


    public void acessaTela(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Aprovação do Cardápio pela Matriz");
        tempo();
        click(selecionaTela);
        tempo();
        waitForElement(telaAprovacao);
        tempo();
        
    }

    public void realizarFiltro(String filtraAgrupamento, String tipoFiltro){
        if(filtraAgrupamento == "S") {
            click(agrupamentoUnidade);
            tempo();
            duploClique(botaoPesquisarFiltro);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca,"0000000002");
            tempo();
            click(selecionaBusca);
            }
        tempo();
        if (tipoFiltro == "Todos") {
            if (!returnIfElementIsSelected(validaCheckBoxTodasUnidades)) {
                click(checkBoxTodasUnidades);
            }
            if (!returnIfElementIsSelected(validaCheckBoxServicos)) {
                click(ckeckBoxTodosServicos);
            }

        }else {
            if (returnIfElementIsSelected(validaCheckBoxTodasUnidades)) {
                click(checkBoxTodasUnidades);
                click(campoUnidade);
            } else {
                click(campoUnidade);
            }
            tempo();
            duploClique(filtroBusca);
            tempo();
            click(campoProcurar);
            clearAndSendKeys(campoProcurar,"0002");
            tempo();
            click(ckeckBoxUnidade);
            click(btnOk);

        tempo();

        if (returnIfElementIsSelected(validaCheckBoxServicos)){
            click(ckeckBoxServico);
            click(campoServico);
        }else {
            click(campoServico);
        }
        tempo();
        click(ckeckBoxServico);
        click(btnOk);
        tempo();
        }
        click(buscaTipoCusto);
        tempo();
        duploClique(botaoPesquisarFiltro);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"Custo Médio Bruto Atual");
        tempo();
        click(selecionaBusca);
        tempo();

        click(btnCalendario);
        tempo();
        click(mudaAnoAprovacao);
        click(mesCardapioAprovacao);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public void aprovaCardapio(){
        click(observacaoGeral);
        clearAndSendKeys(observacaoGeral,"Aprovação do cardápio automação!");
        tempo();
        click(clicarGridTela);
        click(btnSalvarObservacao);
        click(btnOkMensagemAlerta);
        tempo();
        click(selecionaServicoAprovacao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnAprovarCardapio);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
    }

    public String retornaDataAprovacao() {
        return getText(dataAprovacaoCard).substring(0,10);

    }

    public String retornaDataAprovacaoCard() {
        return getText(dtAprovacaoCard).substring(0,10);

    }

    public void aprovaTodosCardapios(){
        click(observacaoGeral);
        clearAndSendKeys(observacaoGeral,"Cardápio aprovado sem ressalvas. Validação da rotina de apro" +
                "vação de Cardápio pela Matriz!");
        click(clicarGridTela);
        tempo();
        click(btnSalvarObservacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
        click(selecionaTodosServicosAprovacao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnAprovarCardapio);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();

    }

    public void cancelaAprovacao(){
        click(observacaoGeral);
        clear(observacaoGeral);
        tempo();
        click(clicarGridTela);
        tempo();
        click(btnSalvarObservacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
        refresh();
        realizarFiltro("N","Todos");
        click(selecionaTodosServicosAprovacao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnCancelarAprovacao);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
    }

    public void validaCamposObrigatorios(){
        tempo();
        click(limparFiltroRealizado);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public String retornaCampoObrigatorioUnidade(){
        return getText(campoObrigatorioUnidade);
    }

    public String retornaCampoObrigatorioServico(){
        return getText(campoObrigatorioServico);
    }

    public String retornaCampoObrigatorioTipoCusto(){
        return getText(campoObrigatorioCusto);
    }

    public String retornaCampoObrigatorioCardadio(){
        return getText(campoObrigatorioCardapio);
    }

}
