package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.annotations.Test;

public class PontoDeEntregaPage extends PageBase {

    By clicaMenu = By.xpath("//*[@type = 'button']");
    By campoProcurar = By.xpath("//input[@class = 'zh-input-search-menu mousetrap ng-pristine ng-untouched ng-valid ng-empty']");
    By clicarPontoDeEntrega = By.xpath("//*[contains(text(),'Ponto de Entrega')]");
    By msgEncontrada = By.xpath("//*[@id='header']/div/div[2]/div[2]");
    By msgEncontrada_1 = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/section/section/div/section/div/form/section/div/div[1]/div[2]/div/div[2]/span");
    By msgEncontrada_2 = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/section/section/div/section/div/form/section/div/div[1]/div[1]/div/div[2]/span");
    By btnAdicionaPonto = By.xpath("//*[@id='footer']/div[2]/ul/li[1]");
    By limpaFiltroFilial = By.xpath("//span[@zh-icon='no-border close-x']");
    By filtroFilial = By.xpath("//div[@id = 'FILTER_FILIAL']/span");
    By inputUnidade = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By codigoPontoEntrega = By.xpath("//input[@id='CDDESTFILI']");
    By nomePontoEntrega = By.xpath("//input[@id='NMDESTFILI']");
    By endePontoEntrega = By.xpath("//input[@id='DSENDEDESTFILI']");
    By btnSalvar = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By alertMensagemOk = By.xpath("//button[@class = 'zh-alert-button']");
    By msgEsperadaCodigo050 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[1]/span");
    By msgEsperadaCodigo051 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[1]/span");
    By msgEsperadaNome050 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/span");
    By msgEsperadaEndereco050 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/span");
    By msgEsperadaNome = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[2]/span");
    By msgEsperadaEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[3]/span");

    By msgEncontradaNomeEditado = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/span");
    By msgEncontrataEnderecoEditado = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/span");
    By msgEncontradaEdicaoNome = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[2]/span");
    By msgEncontradaEdicaoEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[3]/span");


    //Ação de editar
    By clicaNomePontoEntrega = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/div");
    By novoNomePontoEntrega = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/div/input");
    By campoEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/div");
    By novoEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/div/input");
    By clicaNomePontoEntrega003 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[2]/div");
    By novoNomePontoEntrega003 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[2]/div/input");
    By campoEndereco003 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[3]/div");
    By novoEnderecoPonto003 = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[3]/div[3]/div/input");
    By btnSalvarAlteracao = By.xpath("//*[text() = 'Salvar alterações']");

   //Ações Excluir registros
    By clicaRegistro = By.xpath("//span[contains(text(),'001')]");
    By btnExcluirPonto = By.xpath("//*[@id='footer']/div[2]/ul/li[2]");
    By confirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[contains(text(),'Sim')]");
    By btnOk = By.xpath("//button[@class = 'zh-alert-button']");
    By clicarRegistroExclusao = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]");
    By alertSucessoExclusao = By.xpath("//*[@class='zh-notification-messages']");

    public void navegaPontoDeEntrega(String acaoTela, String CDFILIAL){
        tempo();
        click(clicaMenu);
        tempo();
        click(campoProcurar);
        clearAndSendKeys(campoProcurar,"Ponto de Entrega");
        tempo();
        click(clicarPontoDeEntrega);
        tempo();
        click(limpaFiltroFilial);
        tempo();
        click(filtroFilial);
        tempo();
        click(inputUnidade);
        if (acaoTela != "Editar"){
            sendKeys(inputUnidade, CDFILIAL);
        }else{
            sendKeys(inputUnidade, CDFILIAL);
        }
        tempo();
        click(selecionaUnidade);
        tempo();


    }

    public String confirmaAcessoTela(){
        return getText(msgEncontrada);

    }

    public void validarCamposObrigatorios(){
        tempo();
        click(btnAdicionaPonto);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String campoObrigatorioCodigo(){
        return getText(msgEncontrada_1);
    }

    public void validarRegistrosIguais(){
        click(btnAdicionaPonto);
        tempo();
        click(codigoPontoEntrega);
        sendKeys(codigoPontoEntrega,"001");
        tempo();
        click(nomePontoEntrega);
        sendKeys(nomePontoEntrega, "TESTE AUTOMAÇÃO");
        tempo();
        click(endePontoEntrega);
        sendKeys(endePontoEntrega,"AV. PORTUGAL, 120");
        tempo();
        click(btnSalvar);
        tempo();
        click(alertMensagemOk);
        tempo();
    }

    public String campoObrigatorioNome(){
        return getText(msgEncontrada_2);
    }

    public void dadosPontoEntrega(String NMPONTOENTREGA, String ENDEPONTOENTREGA) {
        int i = 50;
        while (i < 52) {
            click(btnAdicionaPonto);
            tempo();
            click(codigoPontoEntrega);
            sendKeys(codigoPontoEntrega,String.valueOf(i));
            tempo();
            click(nomePontoEntrega);
            if (Integer.parseInt(String.valueOf(i)) == 50) {
                sendKeys(nomePontoEntrega, NMPONTOENTREGA);
                tempo();
                click(endePontoEntrega);
                sendKeys(endePontoEntrega, ENDEPONTOENTREGA);
            }else {
                sendKeys(nomePontoEntrega, "CLIENTE TEKNISA");
                tempo();
                click(endePontoEntrega);
                sendKeys(endePontoEntrega, "AV. SOLAR DO ENGENHO, 21");
            }
            tempo();
            click(btnSalvar);
            tempo();
            i++;
        }
    }

    public String validaCadastroCodigoPontoEntrega(){
        return getText(msgEsperadaCodigo050);

    }

    public String validaCadastroNomePontoEntrega(){
        return getText(msgEsperadaNome050);

    }

    public String validaCadastroEnderecoPontoEntrega(){
        return getText(msgEsperadaEndereco050);

    }

    public String validarCadastroCodigoPontoEntrega(){
        return getText(msgEsperadaCodigo051);

    }

    public String validarCadastroNomePontoEntrega(){
        return getText(msgEsperadaNome);

    }

    public String validarCadastroEnderecoPontoEntrega(){
        return getText(msgEsperadaEndereco);

    }

    public void alteraPontoDeEntrega(String NMPONTO002,String ENDEPONTO002,String NMEPONTO003,String ENDPONTO003){
        click(clicaNomePontoEntrega);
        clear(novoNomePontoEntrega);
        tempo();
        click(clicaNomePontoEntrega);
        clearAndSendKeys(novoNomePontoEntrega,NMPONTO002);
        tempo();
        click(campoEndereco);
        click(novoEndereco);
        clearAndSendKeys(novoEndereco,ENDEPONTO002);
        click(clicaNomePontoEntrega003);
        click(novoNomePontoEntrega003);
        clearAndSendKeys(novoNomePontoEntrega003,NMEPONTO003);
        click(campoEndereco003);
        click(novoEnderecoPonto003);
        clearAndSendKeys(novoEnderecoPonto003,ENDPONTO003);
        tempo();
        click(btnSalvarAlteracao);
        tempo();

    }

    public String nomeEditado002(){
        return getText(msgEncontradaNomeEditado);
    }
    public String enderecoEditado002(){
        return getText(msgEncontrataEnderecoEditado);
    }
    public String nomeEditado003(){
        return getText(msgEncontradaEdicaoNome);
    }
    public String enderecoEditado003(){
        return getText(msgEncontradaEdicaoEndereco);
    }


    public void apagaPontoDeEntrega(){
        click(clicaRegistro);
        tempo();
        click(btnExcluirPonto);
        tempo();
        click(confirmaExclusao);
        tempo();
        click(btnOk);
        tempo();
        click(clicarRegistroExclusao);
        tempo();
        click(btnExcluirPonto);
        tempo();
        click(confirmaExclusao);
        tempo();
        click(clicarRegistroExclusao);
        tempo();
        click(btnExcluirPonto);
        tempo();
        click(confirmaExclusao);
        tempo();
    }

    public String validaExclusao(){
        return getText(alertSucessoExclusao);
    }

}
