package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class ServicoXDietaPadraoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaServicoXDieta = By.xpath("//span[text() = 'Serviço x Dieta Padrão']");

    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvarAlterasoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By botaoCampoUnidadeFiltroInicial = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By campoUnidadeFiltoInicial = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"12544448451625001447966\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By campoServicoFiltroInicial = By.id("NMSERVICO");
    By servicoJantar = By.xpath("//div[@data-zh-id=\"12544448451021542429973\"]//span[text() = '00003 | JANTAR']");

    By campoNomeDieta = By.id("DSDIETPAD");
    By dietaFitness = By.xpath("//div[@data-zh-id=\"12544448452726079424962\"]//span[text() = '0001 | FITNESS']");
    By dietaSemAcucar = By.xpath("//div[@data-zh-id=\"12544448452726079424962\"]//span[text() = '0002 | SEM AÇUCAR']");
    By dietaLowCarb = By.xpath("//div[@data-zh-id=\"12544448452726079424962\"]//span[text() = '0003 | LOW CARB']");

    By checkBoxDietaPadrao1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoDietaPadrao1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDDIETPAD\"]/span");
    By nomeDietaPadrao1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSDIETPAD\"]/span");

    By abaDieta = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dieta']");
    By abaClientes = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Clientes']");

    By campoRazaoSocial = By.id("NMRAZSOCCLIE");
    By clienteAguiaFarma = By.xpath("//div[@data-zh-id=\"12544448452179494952941\"]//span[text() = '06.266.262/0007-74 | AGUIA FARMA FARMACEUTICA LTDA']");
    By clienteBigFarma = By.xpath("//div[@data-zh-id=\"12544448452179494952941\"]//span[text() = '01.431.152/0001-01 | BIG FARMA LTDA']");
    By campoPrecoDieta = By.id("VRSERVFATUPAH");
    By codigoAbaDieta = By.xpath("//div[@id=\"span-field-CDDIETPAD\"]//p");
    By nomeAbaDieta = By.xpath("//div[@id=\"span-field-DSDIETPAD\"]//p");

    By checkBoxTodosClientes = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By colunaRazaoSocialAbaClientes = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"tr\"]//div[@data-zh-field-name=\"NMRAZSOCCLIE\"]");
    By checkBoxCliente1 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By inscricaoCliente1 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRINSJURCLIE\"]/span");
    By nomeCliente1 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMRAZSOCCLIE\"]/span");
    By precoDietaCliente1 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRSERVFATUPAH\"]/span");

    By checkBoxCliente2 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By inscricaoCliente2 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NRINSJURCLIE\"]/span");
    By nomeCliente2 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMRAZSOCCLIE\"]/span");
    By precoDietaCliente2 = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"VRSERVFATUPAH\"]/span");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"12544448451625001447966\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"12544448451021542429973\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"12544448452726079424962\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioRazaoSocial = By.xpath("//div[@data-zh-id=\"12544448452179494952941\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPrecoDieta = By.xpath("//div[@data-zh-id=\"12544448453445084602944\"]//div[@class=\"zh-validation\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemNaoHaRegristrosClientes = By.xpath("//div[@id=\"grid-9684654198465498416351989\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By naoHaRegistroDietaTelaInicial = By.xpath("//div[@id=\"grid-6194984984216549849844\"]//div[@class=\"body-content\"]//div[@class=\"col-xs-12\"]//p");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Serviço x Dieta Padrão");
        click(opcaoTelaServicoXDieta);
    }

    public void preencherFiltroInicial() {
        tempo();
        clicarCampoSelecionarValor(campoUnidadeFiltoInicial, unidadeDepositoJabaquara);
        tempo();
        clicarCampoSelecionarValor(campoServicoFiltroInicial, servicoJantar);
        click(botaoAplicarFiltro);
    }

    public void adicionarDieta() {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoNomeDieta, dietaLowCarb);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    public void verificarDietaPadraoAdd() {
        preencherCampoProcurarTelaInicial("0003");
        //valores esperados
        String expCodigo = "0003";
        String expNome = "LOW CARB";

        //valores encontrados
        String encCodigo = getText(codigoDietaPadrao1);
        String encNome = getText(nomeDietaPadrao1);
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código da dieta padrão adicionada");
        Assert.assertEquals(encNome, expNome, "Verificar nome da dieta padrão adicionada");

        click(nomeDietaPadrao1);
        encCodigo = getText(codigoAbaDieta);
        encNome = getText(nomeAbaDieta);
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código na aba dieta, da dieta padrão adicionada");
        Assert.assertEquals(encNome, expNome, "Verificar nome na aba dieta da dieta padrão adicionada");
        click(botaoVoltar);
    }

    public void adicionarClientes() {
        preencherCampoProcurarTelaInicial("0002");
        tempo();
        click(nomeDietaPadrao1);
        tempo();
        click(abaClientes);
        tempo();
        click(botaoAdicionar);

        clicarCampoSelecionarValor(campoRazaoSocial, clienteAguiaFarma);
        tempo();
        sendKeys(campoPrecoDieta, "35,5");
        tempo();
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoRazaoSocial, clienteBigFarma);
        tempo();
        sendKeys(campoPrecoDieta, "40");
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    public void verificarClientesAdicionados() {
        click(colunaRazaoSocialAbaClientes);
        //valores esperados para o primeiro cliente
        String expInscricao = "06.266.262/0007-74";
        String expNomeClinete = "AGUIA FARMA FARMACEUTICA LTDA";
        String expPrecoDieta = "35,50";

        //valores encontrados para o primeiro cliente
        String encInscricao = getText(inscricaoCliente1);
        String encNomeCliente = getText(nomeCliente1);
        String encPrecoDieta = getText(precoDietaCliente1);
        Assert.assertEquals(encInscricao, expInscricao, "Verificar o valor da 'inscrição' do primeiro cliente");
        Assert.assertEquals(encNomeCliente, expNomeClinete, "Verificar o valor da 'nome' do primeiro cliente");
        Assert.assertEquals(encPrecoDieta, expPrecoDieta, "Verificar o valor da 'preço da dieta' do primeiro cliente");

        //valores esperados para o segundo cliente
        expInscricao = "01.431.152/0001-01";
        expNomeClinete = "BIG FARMA LTDA";
        expPrecoDieta = "40,00";

        //valores encontrados para o segundo cliente
        encInscricao = getText(inscricaoCliente2);
        encNomeCliente = getText(nomeCliente2);
        encPrecoDieta = getText(precoDietaCliente2);
        Assert.assertEquals(encInscricao, expInscricao, "Verificar o valor da 'inscrição' do segundo cliente");
        Assert.assertEquals(encNomeCliente, expNomeClinete, "Verificar o valor da 'nome' do segundo cliente");
        Assert.assertEquals(encPrecoDieta, expPrecoDieta, "Verificar o valor da 'preço da dieta' do segundo cliente");
    }

    public void alterarPrecoDieta() {
        preencherCampoProcurarTelaInicial("0001");
        click(nomeDietaPadrao1);
        tempo();
        click(abaClientes);
        tempo();
        alteracaoValorDieta("33,50");
        tempo();
        alteracaoValorDieta("45,00");
    }

    public void tentarExcluirDietaPadrao() {
        preencherCampoProcurarTelaInicial("0001");
        click(checkBoxDietaPadrao1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela para excluir uma dieta padrão");

        click(botaoSim);
        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que não é possível excluir a dieta padrão, pois a mesma possui registros filhos");
        click(botaoOkAlerta);
        click(checkBoxDietaPadrao1);
    }

    public void excluirClientes() {
        tempo();
        click(checkBoxCliente2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela para excluir um cliente");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();

        tempo();
        click(checkBoxCliente1);
        click(botaoExcluir);
        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela para excluir um cliente");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
        tempo();

        mensagemEsperada = "Não há registros";
        mensagem = getText(mensagemNaoHaRegristrosClientes);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro após excluir os clientes");

        click(botaoVoltar);
    }

    public void excluirTodosClientes() {
        tempo();
        click(checkBoxTodosClientes);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela para excluir um cliente");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();

        tempo();
        mensagem = getText(mensagemNaoHaRegristrosClientes);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem informando que não há registros na aba dos clientes, após a exclusão de todos");
        click(botaoVoltar);
    }

    public void excluirDietaPadrao() {
        preencherCampoProcurarTelaInicial("0003");
        click(checkBoxDietaPadrao1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela para excluir uma dieta padrão");

        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();

        mensagem = getText(naoHaRegistroDietaTelaInicial);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação de que após a exclusão, não há dieta padrão encontrada");
    }

    public void campoObrigatorioFiltroInicial() {
        tempo();
        click(botaoCampoUnidadeFiltroInicial);
        click(botaoAplicarFiltro);

        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo unidade do filtro inicial");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo serviço do filtro inicial");

    }

    public void campoObrigatorioAddDietaPadrao() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String nome = getText(mensagemObrigatorioNome);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(nome, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo nome para adicionar uma dieta");
        tempo();
        click(botaoCancelar);
    }

    public void campoObrigatorioAddCliente() {
        preencherCampoProcurarTelaInicial("0002");
        click(nomeDietaPadrao1);
        click(abaClientes);
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String razaoSocial = getText(mensagemObrigatorioRazaoSocial);
        String precoDieta = getText(mensagemObrigatorioPrecoDieta);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(razaoSocial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo razão social para adicionar um cliente");
        Assert.assertEquals(precoDieta, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo razão social para adicionar um cliente");

        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void dietaJaExiste() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoNomeDieta, dietaFitness);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem informando que registro já existe, ao tentar adicionar uma dieta já cadastrada");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
    }

    public void clienteJaExiste() {
        preencherCampoProcurarTelaInicial("0002");
        click(nomeDietaPadrao1);
        tempo();
        click(abaClientes);
        tempo();
        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoRazaoSocial, clienteAguiaFarma);
        sendKeys(campoPrecoDieta, "28");
        click(botaoSalvar);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoRazaoSocial, clienteAguiaFarma);
        sendKeys(campoPrecoDieta, "43");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem informando que registro já existe, ao tentar adicionar um cliente já cadastrado");
        click(botaoOkAlerta);
        click(botaoCancelar);
        tempo();

        excluirTodosClientes();
        tempo();
    }

    private void alteracaoValorDieta(String valor) {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(precoDietaCliente1)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvarAlterasoes);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        String encPrecoDieta = getText(precoDietaCliente1);
        Assert.assertEquals(encPrecoDieta, valor, "Verificar o preço da dieta do primeiro cliente, após a alterar do valor");
    }

    private void verificarMensagemSalvoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Salvo com sucesso.", "Verificação da mensagem de salvo com sucesso, após a exclusão do grupo");
    }

    private void verificarMensagemExcluidoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Excluído com sucesso.", "Verificação da mensagem de excluído com sucesso, após a exclusão do grupo");
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        waitForElementByTime(botaoDeOpcoesDaTela, 15);
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            tempo();
            tempo();
            click(botaoPesquisar);
        }
        tempo();
        clearAndSendKeys(campoProcurar, texto);
        tempo();
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
